# -*- coding: utf-8 -*-

#############################################################################
# Copyright (c) 2014-2018 Redfern Electronics Limited. All rights reserved. #
#############################################################################

import locale

LANGUAGES = {'English': 'english',
             'Cymraeg': 'welsh',
             '中文': 'chinese',
             'Nederlands': 'dutch',
             'čeština': 'czech'}

LOCALES = { 'en': 'english',
            'cy': 'welsh',
            'zh': 'chinese',
            'nl': 'dutch',
            'cs': 'czech'}

#TODO: Launching app by double clicking on OS X means getdefaultlocale() returns (None, None), launching from terminal works.
try:
    language_code = locale.getdefaultlocale()[0][:2]
except TypeError:
    language_code = 'en'

if language_code in LOCALES:
    LANGUAGE = LOCALES[language_code]
else:
    LANGUAGE = 'english'

LANGUAGE = 'english'

welsh = {
    'program start': "cychwyn rhaglen",
    '|is|': "|yn|",
    'analogue|': "analog|",
    'set|': "gosod|",
    'HI': "UCHEL",
    'LO': "ISEL",
    'motor|at|%': "modur|i|%",
    'FORWARD': "YMLAEN",
    'REVERSE': "YN ÔL",
    'STOP': "STOPIO",
    'random|to|': "ar hap o|i|",
    'set sparkle|to|': "gosod sparkle|i|",
    'turn sparkle|off': "troi sparkle|i ffwrdd",
    'set all sparkles to|': "gosod pob sparkle i|",
    'turn all sparkles off': "troi pob sparkle i ffwrdd",
    'wait|seconds': "aros am|eiliad",
    'wait|milliseconds': "aros am|milieiliad",
    'wait until|': "aros tan|",
    'if|then': "os yw|yna",
    'else': "neu",
    'end if': "gorffen",
    'do until|': "gwneud tan|",
    'loop': "dolen diddiwedd",
    'do|times': "gwneud hyn|gwaith",
    'do forever': "gwneud am byth",
    'let|=|': "gosod|=|",
    'increase|by|': "cynyddu|o|",
    'decrease|by|': "lleihau|o|",
    '|and|': "|a|",
    '|or|': "|neu|",
    '|not|': "|nid|",
    'servo|degrees': "modur servo|gradd",
    'distance (cm)|': "pellter (cm)|",
    'Basic': "Syml",
    'Input/Output': "Mewnbwn/Allbwn",
    'Control': "Rheoli",
    'Variables': "Newidynnau",
    'Operators': "Gweithredwyr",
    'Add New Variable': "Ychwanegu newidyn newydd",
    'del': "dileu",
    'rename': "ail-enwi",
    'Duplicate': "Dyblygu",
    'Ready': "Barod",
    'ERROR: Crumble not found!': "GWALL: Methu dod o hyd i'r Crumble",
    'Programming successful!': "Wedi rhaglennu'n llwyddiannus!",
    'Stopped': "Wedi terfynnu",
    'Do you want to save changes?': "Ydych chi eisiau arbed eich newidiadau?",
    'New software available': "Meddalwedd newydd ar gael"
}


chinese = {
    'program start': '程序开始',
    '|is|': '|是|',
    'analogue|': '模拟量|',
    'set|': '设置|',
    'HI': '高电平',
    'LO': '低电平',
    'motor|at|%': '电机|, 转速为|%',
    'FORWARD': '正转',
    'REVERSE': '反转',
    'STOP': '停止',
    'random|to|': '从|至|随机取数',
    'set sparkle|to|': '设置sparkle|为|',
    'turn sparkle|off': '关闭sparkle|',
    'set all sparkles to|': '设置所有sparkle为',
    'turn all sparkles off': '关闭所有sparkle',
    'wait|seconds': '等待|秒',
    'wait|milliseconds': '等待|毫秒',
    'wait until|': '一直等待，直至|',
    'if|then': '如果|那么',
    'else': '否则',
    'end if': '结束',
    'do until|': '一直执行，直至|',
    'loop': '循环',
    'do|times': '一直执行|次',
    'do forever': '永远执行',
    'let|=|': '让|=|',
    'increase|by|': '使|增加|',
    'decrease|by|': '使|减少|',
    '|and|': '|与|',
    '|or|': '|或|',
    '|not|': '|非|',
    'random|to|': '从|至|随机取数',
    'servo|degrees': '舵机|角度',
    'distance (cm)|': '距离（厘米）',
    'Basic': '基本指令',
    'Input/Output': '输入/输出指令',
    'Control': '控制指令',
    'Variables': '变量',
    'Operators': '运算指令',
    'Add New Variable': '添加新变量',
    'del': '删除',
    'rename': '重命名',
    'Duplicate': '复制',
    'Ready': '准备好了',
    'ERROR: Crumble not found!': '错误：没有找到Crumble',
    'Programming successful!': '编程成功!',
    'Stopped': '已停止',
    'Do you want to save changes?': '需要保存更改吗?',
    'New software available': '有可用的新版本'
}


dutch = {
    'program start': 'programma starten',
    '|is|': '|is|',
    'analogue|': 'analoog|',
    'set|': 'maak|',
    'HI': 'HOOG',
    'LO': 'LAAG',
    'motor|at|%': 'motor|op|%',
    'FORWARD': 'VOORUIT',
    'REVERSE': 'ACHTERUIT',
    'STOP': 'STOP',
    'random|to|': 'willekeurig|tot|',
    'set sparkle|to|': 'maak sparkle|',
    'turn sparkle|off': 'zet sparkle|uit',
    'set all sparkles to|': 'maak alle sparkles|',
    'turn all sparkles off': 'zet alle sparkles uit',
    'wait|seconds': 'wacht|seconde',
    'wait|milliseconds': 'wacht|milliseconde',
    'wait until|': 'wacht tot',
    'if|then': 'als|dan',
    'else': 'anders',
    'end if': 'einde als',
    'do until|': 'herhaal tot|',
    'loop': '↻',
    'do|times': 'herhaal|keer',
    'do forever': 'herhaal',
    'let|=|': 'maak|',
    'increase|by|': 'verhoog|met|',
    'decrease|by|': 'verlaag|met|',
    '|and|': '|en|',
    '|or|': '|of|',
    '|not|': '|niet|',
    'servo|degrees': 'servo|graden',
    'distance (cm)|': 'afstand (cm)|',
    'Basic': 'Basis',
    'Input/Output': 'Invoer/Uitvoer',
    'Control': 'Besturen',
    'Variables': 'Variabelen',
    'Operators': 'Functies',
    'Add New Variable': 'Maak een variabele',
    'del': 'verwijder',
    'rename': 'hernoem',
    'Duplicate': 'Dupliceer',
    'Ready': 'Klaar',
    'ERROR: Crumble not found!': 'FOUT: Geen Crumble gevonden',
    'Programming successful!': 'Programmeren geslaagd!',
    'Stopped': 'Gestopt',
    'Do you want to saved changes?': 'Wijzigingen opslaan?',
    'New software available': 'Er is een nieuwe versie beschikbaar'
}

czech = {
    'program start': 'začátek programu',
    '|is|': '|je|',
    'analogue|': 'analog|',
    'set|': 'soubor|',
    'HI': 'HI',
    'LO': 'LO',
    'motor|at|%': 'motor|v|%',
    'FORWARD': 'DOPŘEDU',
    'REVERSE': 'DOZADU',
    'STOP': 'ZASTAVIT',
    'random|to|': 'nahodilý|do|',
    'set sparkle|to|': 'nastavit sprakle|do|',
    'turn sparkle|off': 'zapnout sparkle|z',
    'set all sparkles to|': 'nastavit všechny sparkles do|',
    'turn all sparkles off': 'zapnout všechny sparkles z',
    'wait|seconds': 'počkat|sekundy',
    'wait|milliseconds': 'počkat|milisekundy',
    'wait until|': 'počkat do|',
    'if|then': 'pokud|tak',
    'else': 'další',
    'end if': 'skončit když',
    'do until|': 'fungovat do',
    'loop': 'smyčka',
    'do|times': 'fungovat|časy',
    'do forever': 'fungovat stále',
    'let|=|': 'nechat |=|',
    'increase|by|': 'zvýšit|pomocí|',
    'decrease|by|': 'snížit|pomocí|',
    '|and|': '|a|',
    '|or|': '|nebo|',
    '|not|': '|ne|',
    'servo|degrees': 'servo|stupně',
    'distance (cm)|': 'vzdálenost (cm)|',
    'Basic': 'Základ',
    'Input/Output': 'Vstup/Výstup',
    'Control': 'Ovládání',
    'Variables': 'Proměnné',
    'Operators': 'Operátoři',
    'Add New Variable': 'Přidat Novou Proměnnou',
    'del': 'smazat',
    'rename': 'přejmenovat',
    'Duplicate': 'Kopie',
    'Ready': 'Hotovo',
    'ERROR: Crumble not found!': 'CHYBA: Crumble nenalezen!',
    'Programming successful!': 'Programování úspěšně dokončeno!',
    'Stopped': 'Zastaveno',
    'Do you want to save changes?': 'Chcete uložit změny?',
    'New software available': 'Je k dispozici nový software'
}

def _(text):
    if LANGUAGE == 'chinese':
        try:
            return chinese[text]
        except:
            return text
    elif LANGUAGE == 'welsh':
        try:
            return welsh[text]
        except:
            return text
    elif LANGUAGE == 'dutch':
        try:
            return dutch[text]
        except:
            return text
    elif LANGUAGE == 'czech':
        try:
            return czech[text]
        except:
            return text
    else:
        return text
